%{
/***********************************************************************
Cpal.yacc source input file for yacc parser generator
main function located in cpal.lex file
***********************************************************************/

#include "lex.yy.c"
#include "include.h"
#include "funcs.h"
#include "tab.h"

#define YYDEBUG 0
#define YYSTYPE rettype


void funcs(A_node n)
{
   printf("%d\n",n->entity);
}

%}
%token VAR INT REAL STRING BOOLE ARRAY OF BEGN END READ WRITE IF THEN ELSE WHILE DO RETURN
%token ID NUM FLOAT STRLIT
%token OPNOT OPMULT OPDIV OPMOD OPADD OPSUB OPLT OPGT OPEQ OPNEQ OPLTE OPGTE OPOR OPAND OPSET
%token SEPRBK SEPLBK SEPLPAR SEPRPAR SEPCOL SEPSEMI SEPCOM SEPDD
%token ERROR
%start program
%%
/****************************************************************
Begin the main program reduction
****************************************************************/
program:	ID SEPSEMI body END ID
	 	{
		int i;
		$$.u.anode=$3.u.anode;
		$$.u.anode->lineno=$1.lineno;
		$$.u.anode->u.decl.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy($$.u.anode->u.decl.id,$1.u.strval);
		if (strcmp($1.u.strval,$5.u.strval)!=0){
		  printf("Error[%d], program %s does not match %s.\n",$1.lineno,$1.u.strval,$5.u.strval);
                globerr=-1;
                }
		travprg($$.u.anode);
		/*printf("\nCompiler returned [%d]\n",globerr);*/
#ifndef source_list_off
		printf("\n************** Source Listing **************\n");
		prtprg($$.u.anode);
		printf("\n");
#endif
		}
body:		sublist statementblock
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=NULL;
		node->u.decl.u.prog.subdecl=$1.u.anode;
		node->u.decl.u.prog.stmtblk=$2.u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|statementblock
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=NULL;
		node->u.decl.u.prog.subdecl=NULL;
		node->u.decl.u.prog.stmtblk=$1.u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|declist sublist statementblock
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=$1.u.anode;
		node->u.decl.u.prog.subdecl=$2.u.anode;
		node->u.decl.u.prog.stmtblk=$3.u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|declist statementblock
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=progDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.prog.declist=$1.u.anode;
		node->u.decl.u.prog.subdecl=NULL;
		node->u.decl.u.prog.stmtblk=$2.u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
/*****************************************************************************
Recognizes Various variable and Constant Declarations
*****************************************************************************/
declist:	declaration
		{
		$$.u.anode=$1.u.anode;
		}
		|declaration declist
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->u.decl.next=$2.u.anode;
		}
declaration:	vardec SEPSEMI
		{
		$$.u.anode=$1.u.anode;
		}
		|constdec
		{
		$$.u.anode=$1.u.anode;
		}
vardec:		VAR idlist SEPCOL type
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.lineno;
		node->u.decl.kind=varDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.var.idList=$2.u.anode;
		node->u.decl.u.var.typ=$4.u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
idlist:		ident
		{
		$$.u.anode=$1.u.anode;
		} 
		|ident SEPCOM idlist
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->u.idlist.next=$3.u.anode;
		}
ident:		ID
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=idTag;
		node->lineno=$1.lineno;
		node->u.idlist.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.idlist.id,$1.u.strval);
		node->u.idlist.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
type:		base
		{
		$$.u.anode=$1.u.anode;
		}
		|array
		{
		$$.u.anode=$1.u.anode;
		}
base:		INT
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=intTy;
		node->next=NULL;
		$$.u.anode=node;
		}
		|REAL
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=realTy;
		node->next=NULL;
		$$.u.anode=node;
		}
		|STRING
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=strTy;
		node->next=NULL;
		$$.u.anode=node;
		}
		|BOOLE
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=baseTy;
		node->u.typ.base=boolTy;
		node->next=NULL;
		$$.u.anode=node;
		}
array:		ARRAY SEPLBK range SEPRBK OF base
		{
		$$.u.anode=$3.u.anode;
		$$.u.anode->u.typ.base=$6.u.anode->u.typ.base;
		free($6.u.anode);
		}
range:		subrange
		{
		$$.u.anode=$1.u.anode;
		}
		|subrange SEPCOM range
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->next=$3.u.anode;
		}
subrange:	NUM
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=inttyp;
		node->u.typ.r1.num=$1.u.intval;
		node->next=NULL;
		$$.u.anode=node;
		}
		|ID
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=consttyp;
		node->u.typ.r1.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.typ.r1.id,$1.u.strval);
		node->next=NULL;
		$$.u.anode=node;
		}
		|idnum SEPDD idnum
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->u.typ.kind=array2Ty;
		$$.u.anode->u.typ.base2=$3.u.anode->u.typ.base1;
		switch ($3.u.anode->u.typ.base1)
		{
		case inttyp:
		case subinttyp:
		  $$.u.anode->u.typ.r2.num=$3.u.anode->u.typ.r1.num;
		  break;
		case consttyp:
		  $$.u.anode->u.typ.r2.id=$3.u.anode->u.typ.r1.id;
		  break;
		default:
		  printf("Error[%d]!!, invalid type.%d\n",$1.lineno,$3.u.anode->u.typ.base1);
                  globerr=-1;
		}
		free($3.u.anode);
		}
idnum:		ID
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=consttyp;
		node->u.typ.r1.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.typ.r1.id,$1.u.strval);
		node->next=NULL;
		$$.u.anode=node;
		}
		|negnum
		{
		$$.u.anode=$1.u.anode;
		}
negnum:		NUM
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=inttyp;
		node->u.typ.r1.num=$1.u.intval;
		node->next=NULL;
		$$.u.anode=node;
		}
		|OPSUB NUM
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=typTag;
		node->lineno=$1.lineno;
		node->u.typ.kind=array1Ty;
		node->u.typ.base1=subinttyp;
		node->u.typ.r1.num=$2.u.intval;
		node->next=NULL;
		$$.u.anode=node;
		}
constdec:	VAR idlist SEPCOL const SEPSEMI
		{
		$$.u.anode=$4.u.anode;
		$$.u.anode->u.decl.u.cnst.idList=$2.u.anode;
		}
const:		OPSUB numfloatstr
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=NULL;
		switch ($2.u.anode->u.oper.kind)
		{
		case number:	
		  node->u.decl.u.cnst.kind=subinttyp;
		  node->u.decl.u.cnst.val.intval=$2.u.anode->u.oper.u.intval;
		  break;
		case real:
		  node->u.decl.u.cnst.kind=subrealtyp;
		  node->u.decl.u.cnst.val.realval=$2.u.anode->u.oper.u.realval;
		  break;
		case str:
		  printf("Error[%d], invalid '-' before string\n",$1.lineno);
                  globerr=-1;
		  node->u.decl.u.cnst.kind=strtyp;
		  node->u.decl.u.cnst.val.strval=$2.u.anode->u.oper.u.strval;
		  break;
		default:
		  printf("Error! Invalid type.\n");
                  globerr=-1;
		}
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|OPADD numfloatstr
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=NULL;
		switch ($2.u.anode->u.oper.kind)
		{
		case number:	
		  node->u.decl.u.cnst.kind=addinttyp;
		  node->u.decl.u.cnst.val.intval=$2.u.anode->u.oper.u.intval;
		  break;
		case real:
		  node->u.decl.u.cnst.kind=addrealtyp;
		  node->u.decl.u.cnst.val.realval=$2.u.anode->u.oper.u.realval;
		  break;
		case str:
		  printf("Error[%d], invalid '+' before string\n",$1.lineno);
                  globerr=-1;
		  node->u.decl.u.cnst.kind=strtyp;
		  node->u.decl.u.cnst.val.strval=$2.u.anode->u.oper.u.strval;
		  break;
		default:
		  printf("Error! Invalid type.\n");
                  globerr=-1;
		}
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|numfloatstr
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=NULL;
		switch ($1.u.anode->u.oper.kind)
		{
		case number:	
		  node->u.decl.u.cnst.kind=inttyp;
		  node->u.decl.u.cnst.val.intval=$1.u.anode->u.oper.u.intval;
		  break;
		case real:
		  node->u.decl.u.cnst.kind=realtyp;
		  node->u.decl.u.cnst.val.realval=$1.u.anode->u.oper.u.realval;
		  break;
		case str:
		  node->u.decl.u.cnst.kind=strtyp;
		  node->u.decl.u.cnst.val.strval=$1.u.anode->u.oper.u.strval;
		  break;
		default:
		  printf("Error! Invalid type.\n");
                  globerr=-1;
		}
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|ID
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.lineno;
		node->u.decl.kind=constDecl;
		node->u.decl.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.decl.id,$1.u.strval);
		node->u.decl.u.cnst.kind=consttyp;
		node->u.decl.u.cnst.idList=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
/*****************************************************************************
Handles Subroutine Declarations and lists of subroutines
*****************************************************************************/
sublist:	sub
		{
		$$.u.anode=$1.u.anode;
		}
		|sub sublist
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->u.decl.u.sub.next=$2.u.anode;
		}
sub:		subheading subbody END ID
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->u.decl.u.sub.stmtblk=$2.u.anode;
		if(strcmp($1.u.anode->u.decl.id,$4.u.strval)!=0){
		  printf("Error[%d], sub %s declaration ended with %s.\n",$1.lineno,$1.u.anode->u.decl.id, $4.u.strval);
                  globerr=-1;
                }
		}
subbody:	statementblock
		{
		$$.u.anode=$1.u.anode;
		}
subheading:	ID SEPLPAR arglist SEPRPAR SEPCOL base SEPSEMI
		{
		$$.u.anode=$3.u.anode;
		$$.u.anode->lineno=$1.lineno;
		$$.u.anode->u.decl.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy($$.u.anode->u.decl.id,$1.u.strval);
		$$.u.anode->u.decl.u.sub.rettype=$6.u.anode;
		}
		|ID SEPLPAR arglist SEPRPAR SEPSEMI
		{
		$$.u.anode=$3.u.anode;
		$$.u.anode->lineno=$1.lineno;
		$$.u.anode->u.decl.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy($$.u.anode->u.decl.id,$1.u.strval);
		}
		|ID SEPLPAR SEPRPAR SEPSEMI
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.decl.id,$1.u.strval);
		node->u.decl.u.sub.reflist=NULL;
		node->u.decl.u.sub.vallist=NULL;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|ID SEPLPAR SEPRPAR SEPCOL base SEPSEMI
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.decl.id,$1.u.strval);
		node->u.decl.u.sub.reflist=NULL;
		node->u.decl.u.sub.vallist=NULL;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=$5.u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
/*****************************************************************************
Recognizes Various miscellaneous lists and blocks of code
*****************************************************************************/
exprlist:	expression SEPCOM expression
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->next=$3.u.anode;
		}
		|expression SEPCOM exprlist
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->next=$3.u.anode;
		}
arglist:	byvallist 
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.sub.reflist=NULL;
		node->u.decl.u.sub.vallist=$1.u.anode;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|byreflist
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.sub.reflist=$1.u.anode;
		node->u.decl.u.sub.vallist=NULL;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
 		|byvallist SEPSEMI byreflist
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=subroutineDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.sub.reflist=$3.u.anode;
		node->u.decl.u.sub.vallist=$1.u.anode;
		node->u.decl.u.sub.stmtblk=NULL;
		node->u.decl.u.sub.rettype=NULL;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
byvallist:	byvallist SEPSEMI listelem
		{
		A_node idx;
		$$.u.anode=$1.u.anode;
		idx=$$.u.anode;	//initializes index
		while(idx->u.decl.next!=NULL)
		  idx=idx->u.decl.next;	//traverses list
		idx->u.decl.next=$3.u.anode;	//adds element at end of list
		}
		|listelem
		{
		$$.u.anode=$1.u.anode;
		}
listelem:	idlist SEPCOL type
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=declTag;
		node->lineno=$1.u.anode->lineno;
		node->u.decl.kind=varDecl;
		node->u.decl.id=NULL;
		node->u.decl.u.var.idList=$1.u.anode;
		node->u.decl.u.var.typ=$3.u.anode;
		node->u.decl.next=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
byreflist:	VAR byvallist
		{
		$$.u.anode=$2.u.anode;
		}
statementblock:	BEGN END
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|BEGN blockbody END
		{
		$$.u.anode=$2.u.anode;
		}
blockbody:	declist statementlist
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.u.anode->lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=$1.u.anode;
		node->u.stmt.stmtlist=$2.u.anode;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|statementlist
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.u.anode->lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=$1.u.anode;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|declist
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.u.anode->lineno;
		node->u.stmt.kind=stmtblk;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=$1.u.anode;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
/*****************************************************************************
Recognizes Statement lists and statements
*****************************************************************************/
statementlist:	statement statementlist
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->next=$2.u.anode;
		}
		|statement
		{
		$$.u.anode=$1.u.anode;
		}
statement:	assignment SEPSEMI
		{
		$$.u.anode=$1.u.anode;
		}
		|subcalls SEPSEMI
		{
		$$.u.anode=$1.u.anode;
		}
		|io SEPSEMI
		{
		$$.u.anode=$1.u.anode;
		}
		|conditional SEPSEMI
		{
		$$.u.anode=$1.u.anode;
		}
		|flowctrl SEPSEMI
		{
		$$.u.anode=$1.u.anode;
		}
		|statementblock SEPSEMI	
		{
		$$.u.anode=$1.u.anode;
		}
assignment:	variable OPSET expression
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.u.anode->lineno;
		node->u.stmt.kind=assignstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=$1.u.anode;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
subcalls:	ID SEPLPAR expression SEPRPAR
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=subcalls;
		node->u.stmt.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.stmt.id,$1.u.strval);
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|ID SEPLPAR exprlist SEPRPAR
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=subcalls;
		node->u.stmt.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.stmt.id,$1.u.strval);
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|ID SEPLPAR SEPRPAR
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=subcalls;
		node->u.stmt.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.stmt.id,$1.u.strval);
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
io:		readio
		{
		$$.u.anode=$1.u.anode;
		}
		|writeio
		{
		$$.u.anode=$1.u.anode;
		}
readio:		READ variable
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=readstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=$2.u.anode;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
writeio:	WRITE exprlist
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=writestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|WRITE expression
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=writestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
conditional:	IF expression THEN statementlist ifend
		{
		$$.u.anode=$5.u.anode;
		$$.u.anode->lineno=$1.lineno;
		$$.u.anode->u.stmt.exprlist=$2.u.anode;
		$$.u.anode->u.stmt.stmtlist=$4.u.anode;
		}
		|IF expression THEN ifend
		{
		$$.u.anode=$4.u.anode;
		$$.u.anode->lineno=$1.lineno;
		$$.u.anode->u.stmt.exprlist=$2.u.anode;
		}
ifend:		END IF
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=ifstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|ELSE statementlist END IF
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=ifstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=$2.u.anode;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
		|ELSE END IF
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=ifstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
flowctrl:	whilestmt
		{
		$$.u.anode=$1.u.anode;
		}
		|retstmt
		{
		$$.u.anode=$1.u.anode;
		}
whilestmt:	WHILE expression DO statementlist END WHILE
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=whilestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=$4.u.anode;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|WHILE expression DO END WHILE
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=whilestmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
retstmt:	RETURN expression
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=returnstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|RETURN
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=stmtTag;
		node->lineno=$1.lineno;
		node->u.stmt.kind=returnstmt;
		node->u.stmt.id=NULL;
		node->u.stmt.var=NULL;
		node->u.stmt.declist=NULL;
		node->u.stmt.stmtlist=NULL;
		node->u.stmt.elselist=NULL;
		node->u.stmt.exprlist=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
/*****************************************************************************
Recognize Variables as simple variables or array elements
*****************************************************************************/
variable:	ID
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=varTag;
		node->lineno=$1.lineno;
		node->u.var.kind=varvar;
		node->u.var.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy(node->u.var.id,$1.u.strval);
		node->next=NULL;
		$$.u.anode=node;
		}
		|arrelement
		{
		$$.u.anode=$1.u.anode;
		}
arrelement:	ID SEPLBK scindex SEPRBK	
		{
		$$.u.anode=$3.u.anode;
		$$.u.anode->u.var.id=(char *)malloc(strlen($1.u.strval)+1);
		strcpy($$.u.anode->u.var.id, $1.u.strval);
		$$.u.anode->u.var.kind=arrvar;
		}
scindex:	index
		{
		$$.u.anode=$1.u.anode;
		}
		|index SEPCOM scindex
		{
		$$.u.anode=$1.u.anode;
		$$.u.anode->u.var.idxlist.next=$3.u.anode;
		}
index:		expression
		{
                A_node node;
                node=(A_node)malloc(sizeof(struct A_Node));
                node->entity=varTag;
                node->lineno=$1.lineno;
                node->u.var.idxlist.expr=$1.u.anode;
                node->u.var.idxlist.next=NULL;
                node->u.var.id=NULL;
                node->next=NULL;
                $$.u.anode=node;
		}
/****************************************************************************
Recognize Expressions with order of precedence built in
****************************************************************************/
expression:	logic
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=ex;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=NULL;
		node->next=NULL;
		$$.u.anode=node;
		}
logic:		logic OPOR andlog
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=or;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|andlog
		{
		$$.u.anode=$1.u.anode;
		}
andlog:		andlog OPAND relate
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=and;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|relate
		{
		$$.u.anode=$1.u.anode;
		}
relate:		relate OPGT arith
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=gt;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|relate OPLT arith
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=lt;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|relate OPGTE arith
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=gteq;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|relate OPLTE arith
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=lteq;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|relate OPEQ arith
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=eq;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|relate OPNEQ arith
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=neq;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|arith
		{
		$$.u.anode=$1.u.anode;
		}
arith:		arith OPADD mult
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=add;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|arith OPSUB mult
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=sub;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|mult
		{
		$$.u.anode=$1.u.anode;
		}
mult:		mult OPMULT unary
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=mult;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|mult OPDIV unary
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=divide;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|mult OPMOD unary
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.u.anode->lineno;
		node->u.expr.kind=mod;
		node->u.expr.operand1=$1.u.anode;
		node->u.expr.operand2=$3.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|unary
		{
		$$.u.anode=$1.u.anode;
		}
unary:		OPNOT factor
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.lineno;
		node->u.expr.kind=not;
		node->u.expr.operand1=NULL;
		node->u.expr.operand2=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;		
		}
		|OPSUB factor
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.lineno;
		node->u.expr.kind=sub;
		node->u.expr.operand1=NULL;
		node->u.expr.operand2=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|OPADD factor
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=expTag;
		node->lineno=$1.lineno;
		node->u.expr.kind=add;
		node->u.expr.operand1=NULL;
		node->u.expr.operand2=$2.u.anode;
		node->next=NULL;
		$$.u.anode=node;
		}
		|factor
		{
		$$.u.anode=$1.u.anode;
		}
/****************************************************************************
Recognize Primitives
****************************************************************************/
factor:		SEPLPAR expression SEPRPAR
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=$1.lineno;
		node->u.oper.kind=expr;
		node->u.oper.u.expr=$2.u.anode;	
		node->next=NULL;
		$$.u.anode=node;		
		}
		|numfloatstr
		{
		$$.u.anode=$1.u.anode;
		}
		|variable
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=$1.u.anode->lineno;
		node->u.oper.kind=variable;
		node->u.oper.u.var=$1.u.anode;	
		node->next=NULL;
		$$.u.anode=node;
		}
		|subcalls
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=$1.u.anode->lineno;
		node->u.oper.kind=subcall;
		node->u.oper.u.subcall=$1.u.anode;	
		node->next=NULL;
		$$.u.anode=node;
		}
numfloatstr:	NUM
  		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=$1.lineno;
		node->u.oper.kind=number;
		node->u.oper.u.intval=$1.u.intval;	
		node->next=NULL;
		$$.u.anode=node;
		}
numfloatstr:	FLOAT
		{	
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=$1.lineno;
		node->u.oper.kind=real;
		node->u.oper.u.realval=$1.u.realval;	
		node->next=NULL;
		$$.u.anode=node;
		}
numfloatstr:	STRLIT
		{
		A_node node;
		node=(A_node)malloc(sizeof(struct A_Node));
		node->entity=operTag;
		node->lineno=$1.lineno;
		node->u.oper.kind=str;
		node->u.oper.u.strval=$1.u.strval;	
		node->next=NULL;
		$$.u.anode=node;
		}
%%
