/***************************************************************************
Semantic analyzing functions used by funcs.h during AST traversal
***************************************************************************/

#ifndef semantic_h
#define semantic_h

#include "include.h"
#include "tab.h"

int expreval(A_node expr, rettype **val);



int chkadd(int op1, int op2, int line, rettype *val, rettype *val2, rettype **rval)
/************************************************************************
Checks validity of operant types for add operation
************************************************************************/
{
  int ret=-1;

  if ((op1==-1)||(op2==-1)) return -1;
  switch(op1&taBOOLE)
    {
    case tINT:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tINT;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST)) 
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.intval=val->u.intval+val2->u.intval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	      op1=op1|tCONST;
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.intval+val2->u.realval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);
	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tREAL:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.realval+val2->u.intval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.realval+val2->u.realval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);
	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tSTRING:
      if ((op2&taBOOLE)==tSTRING)
	{
	  ret=tSTRING;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taINT:
      switch(op2&taBOOLE)
	{
	case taINT:
	  ret=taINT;
	  break;
	case taREAL:
	  ret=taREAL;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taREAL:
      switch(op2&taBOOLE)
	{
	case taINT:
	case taREAL:
	  ret=taREAL;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);
	  
	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taSTRING:
      switch(op2&taBOOLE)
	{
	case taSTRING:
	case tSTRING:
	  ret=taSTRING;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);
	  
	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	  break;
	}
      break;
    case taBOOLE:
      if ((op2&taBOOLE)==taBOOLE)
	{
	  ret=taBOOLE;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    default:
      if (op1==0x0ffff0f)
	{
	  switch(op2&taBOOLE)
	    {
	    case tINT:
	      ret=tINT;
	      if ((rval!=NULL)&&((op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=-val2->u.intval;
		}
	      break;
	    case tREAL:
	      ret=tREAL;
	      if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.realval=val->u.intval-val2->u.realval;
		}
	      break;
	    default:
	      if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
		printf("Error[%d], invalid unary [%s] type ([",line,val2->id);
	      else
		printf("Error[%d], invalid unary type ([",line);
	      
	      prtexpand(op1);
	      printf("]-[");
	      prtexpand(op2);
	      printf("])\n");
	      globerr=-1;
	    }
	}
      else
	{
	  if ((op1&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 1 [%s] type ([",line,val->id);
	  else
	    printf("Error[%d], invalid operand 1 type ([",line);
	  prtexpand(op1);
	  printf("]+[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    }
  ret=ret|(op1&tCONST&op2);
  return ret;
}

int chksub(int op1, int op2, int line, rettype *val, rettype *val2, rettype **rval)
/************************************************************************
Checks validity of operant types for subtract operation
************************************************************************/
{
  int ret=-1,space;

  if ((op1==-1)||(op2==-1)) return -1;
  switch(op1&taBOOLE)
    {
    case tINT:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tINT;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.intval=val->u.intval-val2->u.intval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	      op1=op1|tCONST;
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.intval-val2->u.realval;
	    }	 
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;	    
	}
      break;
    case tREAL:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.realval-val2->u.intval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.realval-val2->u.realval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tSTRING:
      if ((op2&taBOOLE)==tINT)
	{	
	  if (val2!=NULL)
	    {
	      if (val2->u.intval<0)
		{
		  printf("Error[%d], cannot subtract string by negative number\n",line);
		  globerr=-1;
		}
	    }
	  ret=tSTRING;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taINT:
      switch(op2&taBOOLE)
	{
	case taINT:
	  ret=taINT;
	  break;
	case taREAL:
	  ret=taREAL;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taREAL:
      switch(op2&taBOOLE)
	{
	case taINT:
	case taREAL:
	  ret=taREAL;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taSTRING:
      switch(op2&taBOOLE)
	{
	case tINT:
	case taINT:
	  ret=taSTRING;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taBOOLE:
      if ((op2&taBOOLE)==taBOOLE)
	{
	  ret=taBOOLE;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    default:
      if (op1==0x0ffff0f)
	{
	  switch(op2&taBOOLE)
	    {
	    case tINT:
	      ret=tINT;
	      if ((rval!=NULL)&&((op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=-val2->u.intval;
		}
	      break;
	    case tREAL:
	      ret=tREAL;
	      if ((rval!=NULL)&&((op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.realval=val->u.intval-val2->u.realval;
		}
	      break;
	    default:
	      if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
		printf("Error[%d], invalid unary [%s] type ([",line,val2->id);
	      else
		printf("Error[%d], invalid unary type ([",line);
	      
	      prtexpand(op1);
	      printf("]-[");
	      prtexpand(op2);
	      printf("])\n");
	      globerr=-1;
	    }
	}
      else
	{
	  if ((op1&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 1 [%s] type ([",line,val->id);
	  else
	    printf("Error[%d], invalid operand 1 type ([",line);
	  prtexpand(op1);
	  printf("]-[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    }
  ret=ret|(op1&tCONST&op2);
  return ret;
}

int chkmult(int op1, int op2, int line, rettype *val, rettype *val2, rettype **rval)
/************************************************************************
Checks validity of operant types for multiply operation
************************************************************************/
{
  int ret=-1;

  if ((op1==-1)||(op2==-1)) return -1;
  switch(op1&taBOOLE)
    {
    case tINT:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tINT;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.intval=val->u.intval*val2->u.intval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.intval*val2->u.realval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]*[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tREAL:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.realval*val2->u.intval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=val->u.realval*val2->u.realval;
	    }
	  else if ((rval!=NULL)&&((val==NULL)&&((op2&tCONST)==tCONST)))
	    {
	      (*rval)=(rettype *)malloc(sizeof(rettype));
	      (*rval)->u.realval=-val2->u.realval;
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]*[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tSTRING:
      if ((op2&taBOOLE)==tINT)
	{
	  if (val2!=NULL)
	    {
	      if (val2->u.intval<0)
		{
		  printf("Error[%d], cannot multiply string by negative number\n",line);
		  globerr=-1;
		}
	    }
	  ret=tSTRING;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]*[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taSTRING:
      switch(op2&taBOOLE)
	{
	case tINT:
	case taINT:
	  ret=taSTRING;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]*[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taBOOLE:
      if ((op2&taBOOLE)==taBOOLE)
	{
	  ret=taBOOLE;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]*[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    default:
      if ((op1&(tVAR|tCONST))==(tVAR|tCONST))
	printf("Error[%d], invalid operand 1 [%s] type ([",line,val->id);
      else
	printf("Error[%d], invalid operand 1 type ([",line);
      prtexpand(op1);
      printf("]*[");
      prtexpand(op2);
      printf("])\n");
      globerr=-1;
      break;
    }
  ret=ret|(op1&tCONST&op2);
  return ret;
}

int chkdiv(int op1, int op2, int line, rettype *val, rettype *val2, rettype **rval)
/************************************************************************
Checks validity of operant types for division operation
************************************************************************/
{
  int ret=-1;

  if ((op1==-1)||(op2==-1)) return -1;
  switch(op1&taBOOLE)
    {
    case tINT:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tINT;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.intval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=val->u.intval/val2->u.intval;
		}
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.realval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.realval=val->u.intval/val2->u.realval;
		}
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]/[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tREAL:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tREAL;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.intval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=val->u.intval/val2->u.intval;
		}
	    }
	  break;
	case tREAL:
	  ret=tREAL;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.realval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.realval=val->u.realval/val2->u.realval;
		}
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]/[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tSTRING:
      if ((op2&taBOOLE)==tINT)
	{
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.intval<0)
		{
		  printf("Error[%d], cannot divide string by negative number\n",line);
		  globerr=-1;
		}
	    }
	  ret=tSTRING;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]/[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case taSTRING:
      switch(op2&taBOOLE)
	{
	case tINT:
	case taINT:
	  ret=taSTRING;
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]/[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    default:
      if (((op1&(tVAR|tCONST))==(tVAR|tCONST))&&(val->id!=NULL))
	printf("Error[%d], invalid operand 1 [%s] type ([",line,val->id);
      else
	printf("Error[%d], invalid operand 1 type ([",line);
      prtexpand(op1);
      printf("]/[");
      prtexpand(op2);
      printf("])\n");
      globerr=-1;
      break;
    }
  ret=ret|(op1&tCONST&op2);
  return ret;
}

int chkmod(int op1, int op2, int line, rettype *val, rettype *val2, rettype **rval)
/************************************************************************
Checks validity of operant types for modulo operation
************************************************************************/
{
  int ret=-1;

  if ((op1==-1)||(op2==-1)) return -1;
  switch(op1&taBOOLE)
    {
    case tINT:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tINT;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.intval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=val->u.intval%val2->u.intval;
		}
	    }
	  break;
	case tREAL:
	  ret=tINT;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.realval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=val->u.intval%(int)val2->u.realval;
		}
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]%%[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;

    case tREAL:
      switch(op2&taBOOLE)
	{
	case tINT:
	  ret=tINT;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.intval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=(int)val->u.realval%val2->u.intval;
		}
	    }
	  break;
	case tREAL:
	  ret=tINT;
	  if ((val2!=NULL)&&((op2&tCONST)==tCONST))
	    {
	      if (val2->u.intval==0)
		{
		  printf("Error[%d], cannot divide by zero\n",line);
		  globerr=-1;
		  ret=-1;
		}
	      else if ((rval!=NULL)&&((op1&op2&tCONST)==tCONST))
		{
		  (*rval)=(rettype *)malloc(sizeof(rettype));
		  (*rval)->u.intval=(int)val->u.realval%(int)val2->u.realval;
		}
	    }
	  break;
	default:
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]%%[");
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    default:
      if ((op1&(tVAR|tCONST))==(tVAR|tCONST))
	printf("Error[%d], invalid operand 1 [%s] type ([",line,val->id);
      else
	printf("Error[%d], invalid operand 1 type ([",line);
      prtexpand(op1);
      printf("]%%[");
      prtexpand(op2);
      printf("])\n");
      globerr=-1;
      break;
    }
  ret=ret|(op1&tCONST&op2);
  return ret;
}

int chkrel(int op1, int op2, int line, const char *op, rettype *val, rettype *val2, rettype **rval)
/************************************************************************
Checks validity of operant types for relational operation
************************************************************************/
{
  int ret=-1;

  if ((op1==-1)||(op2==-1)) return -1;
  switch(op1&taBOOLE)
    {
    case tINT:
    case tREAL:
      if (((op2&taBOOLE)==tINT)||((op2&taBOOLE)==tREAL))
	{
	  ret=tBOOLE;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]%s[",op);
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    case tSTRING:
      if ((op2&taBOOLE)==tSTRING)
	{
	  ret=tBOOLE;
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);

	  prtexpand(op1);
	  printf("]%s[",op);
	  prtexpand(op2);
	  printf("])\n");
	  globerr=-1;
	}
      break;
    default:
      if ((op1&(tVAR|tCONST))==(tVAR|tCONST))
	printf("Error[%d], invalid operand 1 [%s] type ([",line,val->id);
      else
	printf("Error[%d], invalid operand 1 type ([",line);
      prtexpand(op1);
      printf("]%s[",op);
      prtexpand(op2);
      printf("])\n");
      globerr=-1;
      break;
    }
  ret=ret|(op1&tCONST&op2);
  return ret;
}

int chknot(int op, int line, rettype *val, rettype **rval)
/************************************************************************
Checks validity of operant types for not operation
************************************************************************/
{
  boolecast(&op);

  if ((op==-1)) return -1;
  if ((op&taBOOLE)==tBOOLE)
    return tBOOLE;
  else
    {
      if ((op&(tVAR|tCONST))!=0)
	printf("Error[%d], invalid operand [%s] type (![",line,val->id);
      else
	printf("Error[%d], invalid operand type (![",line);
      prtexpand(op);
      printf("])\n");
      globerr=-1;
    }
  return -1;
}

int chklog(int op1, int op2, int line, const char * op, rettype *val, rettype *val2, rettype **rval)
/************************************************************************
Checks validity of operant types for logical operation
************************************************************************/
{
  if ((op1==-1)||(op2==-1)) return -1;
  boolecast(&op1);
  boolecast(&op2);
  if (((op1&taBOOLE)==tBOOLE)&&((op2&taBOOLE)==tBOOLE))
    return tBOOLE;
  else
    {
      if ((op1&taBOOLE)!=tBOOLE)
	{
	  if ((op1&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 1 [%s] type ([",line,val->id);
	  else
	    printf("Error[%d], invalid operand 1 type ([",line);
	}
      else
	{
	  if ((op2&(tVAR|tCONST))==(tVAR|tCONST))
	    printf("Error[%d], invalid operand 2 [%s] type ([",line,val2->id);
	  else
	    printf("Error[%d], invalid operand 2 type ([",line);
	}
      prtexpand(op1);
      printf("]%s[",op);
      prtexpand(op2);
      printf("])\n");
      globerr=-1;
    }
  return -1;
}

 
int evalvar(A_node prg, rettype **val, int *dim=NULL, int **range=NULL); 
int evaloper(A_node prg, rettype **val,int mode, int *dim=NULL, int **range=NULL);

int trav(A_node op, rettype **val, int mode, int *dim=NULL, int **range=NULL)
{
   int i=0;
   int loc;

   if (op==NULL) return -1;

   switch (op->entity)
     {
    case stmtTag:
      i=varaccess(op->u.stmt.id,NULL,NULL,op->lineno,dim,range,&loc);
      if ((i==0x0ffff)||((i&tFUNCTION)!=tFUNCTION))
	{
	}
      else
	{
	  i=i|64;
	}
      break;
    case expTag:
      if (mode==1)
	i=expreval(op,val);
      if (mode==2)
	i=exprevalparam(op,dim,range);
      break;
    case operTag:
      i=evaloper(op,val,mode,dim,range);
      break;
    case varTag:
      i=evalvar(op,val,dim,range);
      break;
    default:
      printf("Error on line [%d]! [%d]\n",op->lineno,op->entity);
      globerr=-1;
      return -1;
      break;
    }
  return i;
}
 
int evalvar(A_node prg, rettype **val, int *dim, int **range)
{
  int i=0;
  int loc;
  A_node typ;
  
  switch (prg->u.var.kind)
    {
    case arrvar:
      i=varaccess(prg->u.var.id,&typ,0, prg->lineno,dim,range,&loc);
      if ((i&taINT)!=taINT)
	{
	}
      else
	{
	  chkarry(prg,typ);
	  i=(i&0x0ffffef);
	}
      break;
    case varvar:
      i=varaccess(prg->u.var.id,&typ,val, prg->lineno,dim,range,&loc);
      break;
    }
  return i;
}

int evaloper(A_node prg, rettype **val,int mode, int *dim, int **range)
{
  int i=0;
  char x[999];
  if ((dim!=NULL)&&(range!=NULL))
    {
      *dim=0;
      *range=NULL;  
    }
  switch (prg->u.oper.kind)
    {
    case number:
      i=0|tCONST;
      (*val)=(rettype *)malloc(sizeof(rettype));
      (*val)->kind=intTy;
      (*val)->u.intval=prg->u.oper.u.intval;
      break;
    case real:
      i=4|tCONST;
      (*val)=(rettype *)malloc(sizeof(rettype));
      (*val)->kind=realTy;
      (*val)->u.realval=prg->u.oper.u.realval;
      break;
    case str:
      i=8|tCONST;
      break;
    case variable:
      i=trav(prg->u.oper.u.var,val,mode,dim,range);
      if((i&0x0fffff)==0x0ffff)
	{
	  i=-1;
	}      
      else if((i&tFUNCTION)==tFUNCTION)
	{
	  i=-1;
	}
      if ((*val)==NULL)
	(*val)=(rettype *)malloc(sizeof(rettype));
      (*val)->id=(char *) malloc(strlen(prg->u.oper.u.var->u.var.id)+1);
      strcpy((*val)->id,prg->u.oper.u.var->u.var.id);
      break;
    case subcall:
      i=trav(prg->u.oper.u.subcall,val,mode,dim,range);
      if (i!=-1)
	{
	  if ((i&0x0fffff)==0x0ff)
	    {
	      i=-1;
	    }
	  if ((i&0x0fffff)==0x0ffff)
	    {
	      i=-1;
	    }
	}
      break;
    case expr:
      i=trav(prg->u.oper.u.expr,val,mode,dim,range);
      break;
      }
  return i;
}

int expreval(A_node expr, rettype **rval)
{
  /*handle all expression type checking*/
  int typ1=0,typ2=0,result=0;
  rettype *val2=NULL, *val1=NULL;
  A_node getter;
  char *iden1,*iden2;

  typ1=trav(expr->u.expr.operand1,&val1,1);
  typ2=trav(expr->u.expr.operand2,&val2,1);
  if (typ1==-1) typ1=0xffff0f;
  if (typ2==-1) typ2=0xffff0f;

  switch (expr->u.expr.kind)
    {
    case add:
      result=chkadd(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case sub:
      result=chksub(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case mult:
      result=chkmult(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case divide:
      result=chkdiv(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case mod:
      result=chkmod(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case ex:
      result=typ1;
      *rval=val1;
      break;
    default:
      printf("Error[%d], invalid expression in index\n",expr->lineno);
      globerr=-1;
      result=-1;
      break;
    }
  if ((typ1!=0x0ff)&&(typ2!=0x0ff))
    {
      if (((typ1&taINT)==taINT)||((typ2&taINT)==taINT))
	{
	  printf("Error[%d], cannot have array in index\n",expr->lineno);
	  globerr=-1;
	  result=-1;
	}
    }
  free(rval);
  free(val1);
  free(val2);
  return result;
}

int exprevalparam(A_node expr,int *dim, int **range)
{
  /*handle all expression type checking*/
  int typ1=0,typ2=0,result=0;
  rettype **rval=NULL,*r=NULL,*val2=NULL, *val1=NULL;
  int dim1,dim2;
  int *range1,*range2;
  A_node getter;
  char *iden1,*iden2;

  rval=&r;
  typ1=trav(expr->u.expr.operand1,&val1,2,&dim1,&range1);
  typ2=trav(expr->u.expr.operand2,&val2,2,&dim2,&range2);
  if (typ1==-1) typ1=0xffff0f;
  if (typ2==-1) typ2=0xffff0f;

  switch (expr->u.expr.kind)
    {
    case add:
      result=chkadd(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case sub:
      result=chksub(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case mult:
      result=chkmult(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case divide:
      result=chkdiv(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case mod:
      result=chkmod(typ1,typ2, expr->lineno,val1,val2,rval);
      break;
    case lt:
      result=chkrel(typ1,typ2, expr->lineno,"<",val1,val2,rval);
      break;
    case gt:
      result=chkrel(typ1,typ2, expr->lineno,">",val1,val2,rval);
      break;
    case eq:
      result=chkrel(typ1,typ2, expr->lineno,"=",val1,val2,rval);
      break;
    case not:
      result=chknot(typ1, expr->lineno,val1,rval);
      break;
    case neq:
      result=chkrel(typ1,typ2, expr->lineno,"<>",val1,val2,rval);
      break;
    case lteq:
      result=chkrel(typ1,typ2, expr->lineno,"<=",val1,val2,rval);
      break;
    case gteq:
      result=chkrel(typ1,typ2, expr->lineno,">=",val1,val2,rval);
      break;
    case or:
      result=chklog(typ1,typ2, expr->lineno,"||",val1,val2,rval);
      break;
    case and:
      result=chklog(typ1,typ2, expr->lineno,"&&",val1,val2,rval);
      break;
    case ex:
      result=typ1;
      break;
    default:
      printf("Error[%d], invalid expression\n",expr->lineno);
      globerr=-1;
      result=-1;
      break;
    }
  if (((typ1!=0x0ff)&&(typ2!=0x0ff))&&(result!=-1))
    {
      if (((typ1&taINT)==taINT)&&((typ2&taINT)==taINT))
	{
      	  result=drmatch(dim1,range1,dim2,range2,expr->lineno,"operand1","operand2");
	  free(range2);
	}
    }
  if ((result!=-1)&&((dim!=NULL)&&(range!=NULL)))
    {
      *dim=dim1;
      *range=range1;
    }
  free(r);
  free(val1);
  free(val2);
  return result;
}

#endif



