#ifndef generate_h
#define generate_h

#include "include.h"
#include <stdio.h>
#include <string.h>

void openfile(char *inf, FILE **outf, char **ofn)
{
  int idx;
  char *outfn;
  outfn=(char *)malloc(strlen(inf)+3);
  strcpy(outfn,inf);
  idx=strlen(inf);
  while((inf[idx]!='.')&&(idx>=0))
    {
      idx--;
    }
  if (idx<0)
    idx=strlen(inf);
  else
    idx++;
  outfn[idx++]='j';
  outfn[idx++]=0;
  *outf=fopen(outfn,"w");
  *ofn=outfn;
}

void gennewline()
{
  fprintf(fout,"\n");
}

void itoa(char **ch, int i)
{
  int t,len=0;
  char *c;
  t=i;
  while (t>0)
    {
      t=t/10;
      len++;
    }
  t=i;
  c=(char *)malloc(len+1);
  c[len--]=0;
  while (len>=0)
    {
      c[len--]=(t%10)+'0';
      t=t/10;
    }
  *ch=c;
}

void genprgname(char *id)
{
  fprintf(fout,".class public %s ; The name of the class that is being defined\n",id);
  fprintf(fout,".super java/lang/Object ; Extending the java.lang.Object class\n\n");
}

void genstdinit()
{
  fprintf(fout,".method public <init>()V ; Instance initialization method\naload_0\ninvokespecial java/lang/Object/<init>()V\nreturn\n.end method\n");
}

void genbgninc(char *prgid, char *id,int typ, rettype val, int dim, int *range)
{
  int i;
  char *ch=NULL,*buff=NULL;
  if ((typ&taINT)==taINT)
    {
      for(i=0;i<dim;i++)
	{
	  itoa(&ch,range[i]);
	  addstr(&srcbgn,"bipush ");
	  addstr(&srcbgn,ch);
	  addstr(&srcbgn,"\n");
	  free(ch);
	}
      addstr(&srcbgn,"multianewarray ");
      for(i=0;i<dim;i++)
	{
	  addstr(&buff,"[");
	}
      switch(typ&taBOOLE)
	{
	case taINT:
	  addstr(&buff,"I");
	  break;
	case taREAL:
	  addstr(&buff,"F");
	  break;
	case taSTRING:
	  addstr(&buff,"Ljava/lang/String;");
	  break;
	case taBOOLE:
	  addstr(&buff,"I");
	  break;
	}
      addstr(&srcbgn,buff);
      addstr(&srcbgn," ");
      itoa(&ch,dim);
      addstr(&srcbgn,ch);
      free(ch);
      addstr(&srcbgn,"\n");
      addstr(&srcbgn,"putstatic ");
      addstr(&srcbgn,prgid);
      addstr(&srcbgn,"/");
      addstr(&srcbgn,id);
      addstr(&srcbgn," ");
      addstr(&srcbgn,buff);
      addstr(&srcbgn,"\n");
      free(buff);
    }
}

void genglob(char *id,int typ, rettype val, int dim, int *range)
{
  char *options;
  int i;
  options=(char *)malloc(dim+20);
  for(i=0;i<dim;i++)
    {
      options[i]='[';
    }
  options[i]=0;
  switch (typ&taBOOLE)
    {
    case tINT:
      options[0]='I';
      options[1]=0;
      break;
    case tREAL:
      options[0]='F';
      options[1]=0;
      break;
    case tSTRING:
      strcpy(options,"Ljava/lang/String;");
      break;
    case tBOOLE:
      options[0]='B';
      options[1]=0;
      break;
    case taINT:
      options[i+0]='I';
      options[i+1]=0;
      break;
    case taREAL:
      options[i+0]='F';
      options[i+1]=0;
      break;
    case taSTRING:
      strcat(options,"Ljava/lang/String;");
      break;
    case taBOOLE:
      options[i+0]='B';
      options[i+1]=0;
      break;
    }
  
  fprintf(fout,".field public static");
  if ((typ&tCONST)==tCONST)
    {
    fprintf(fout," final %s %s = ",id, options);
    switch (typ&taBOOLE)
      {
      case tINT:
	fprintf(fout,"%d",val.u.intval);
	break;
      case tREAL:
	fprintf(fout,"%10f",val.u.realval);
	break;
      case tSTRING:
	fprintf(fout,"\"%s\"",val.u.strval);
	break;
      }
    }
  else
    fprintf(fout," %s %s",id, options);
  fprintf(fout,"\n");
  free(options);
}

void genmainhead()
{
  fprintf(fout,".method public static main([Ljava/lang/String;)V\n");
  fprintf(fout,".limit stack 10\n.limit locals 20\n");
  if (srcbgn!=NULL)
    fprintf(fout,srcbgn);
  free(srcbgn);
  srcbgn=NULL;
}

void genmainend()
{
  fprintf(fout,"return\n.end method\n");
}

void genaccess(int loc)
{
  if (loc<=3)
    fprintf(fout,"iload_%d\n",loc);
  else
    fprintf(fout,"iload %d\n",loc);
}

void gensubhead1(char *id)
{
  fprintf(fout,"\n.method public static %s(",id);
}

void gensubheadmid(int typ,int dim)
{
  int idx;
  if ((typ&taINT)==taINT)
    for (idx=0;idx<dim;idx++)
      fprintf(fout,"[");
  switch (typ&tBOOLE)
    {
    case tINT:
      fprintf(fout,"I");
      break;
    case tREAL:
      fprintf(fout,"F");
      break;
    case tSTRING:
      fprintf(fout,"Ljava/lang/String;");
      break;
    case tBOOLE:
      fprintf(fout,"B");
      break;
    }
}

void gensubend(int typ)
{
  if (typ==0x0ff)
    {
      fprintf(fout,"return\n");
    }
  else
    {
      switch (typ&tBOOLE)
	{
	case tINT:
	  fprintf(fout,"ireturn\n");
	  break;
	case tREAL:
	  fprintf(fout,"freturn\n");
	  break;
	case tSTRING:
	  fprintf(fout,"areturn\n");
	  break;
	case tBOOLE:
	  fprintf(fout,"ireturn\n");
	  break;
	}
    }
  fprintf(fout,".end method\n");
}

void gensubhead2(int typ)
{
  fprintf(fout,")");
  if (typ==0x0ff)
    {
      fprintf(fout,"V");
    }
  else
    {
      switch (typ&tBOOLE)
	{
	case tINT:
	  fprintf(fout,"I");
	  break;
	case tREAL:
	  fprintf(fout,"F");
	  break;
	case tSTRING:
	  fprintf(fout,"Ljava/lang/String;");
	  break;
	case tBOOLE:
	  fprintf(fout,"B");
	  break;
	}
    }
  fprintf(fout,"\n");
  fprintf(fout,".limit stack 10\n.limit locals 20\n");
}

void gensubcall1(char *prgid, char *subid)
{
  fprintf(fout,"invokestatic %s.%s(",prgid,subid);
}

void gensubcallmid(int typ,int dim)
{
  int idx;
  if ((typ&taINT)==taINT)
    for (idx=0;idx<dim;idx++)
      fprintf(fout,"[");
  switch (typ&tBOOLE)
    {
    case tINT:
      fprintf(fout,"I");
      break;
    case tREAL:
      fprintf(fout,"F");
      break;
    case tSTRING:
      fprintf(fout,"Ljava/lang/String;");
      break;
    case tBOOLE:
      fprintf(fout,"B");
      break;
    }
}

void gensubcall2(int typ)
{
  fprintf(fout,")");
  if (typ==0x0ff)
    {
      fprintf(fout,"V");
    }
  else
    {
      switch (typ&tBOOLE)
	{
	case tINT:
	  fprintf(fout,"I");
	  break;
	case tREAL:
	  fprintf(fout,"F");
	  break;
	case tSTRING:
	  fprintf(fout,"Ljava/lang/String;");
	  break;
	case tBOOLE:
	  fprintf(fout,"B");
	  break;
	}
    }
  fprintf(fout,"\n");
}

void genaddcode(int result)
{
  switch(result&taBOOLE)
    {
    case tINT:
      fprintf(fout,"iadd\n");
      break;
    case tREAL:
      fprintf(fout,"fadd\n");
      break;
    case tSTRING:
      fprintf(fout,"invokestatic cs132.Concat(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;\n");
      break;
      /*array expressions skipped*/
  }
}

void gensubcode(int result, int ops)
{
  if (ops==2)
    {
      switch(result&taBOOLE)
	{
	case tINT:
	  fprintf(fout,"isub\n");
	  break;
	case tREAL:
	  fprintf(fout,"fsub\n");
	  break;
	case tSTRING:
	  fprintf(fout,"invokestatic cs132.DropBack(Ljava/lang/String;I)Ljava/lang/String;\n");
	  /*array expressions skipped*/
	}
    }
  else
    {
      switch(result&taBOOLE)
	{
	case tINT:
	  fprintf(fout,"ineg\n");
	  break;
	case tREAL:
	  fprintf(fout,"fneg\n");
	  break;
	}
    }
}

void genmultcode(int result)
{
  char lbl0[6];
  char lbl1[6];

  switch(result&taBOOLE)
    {
    case tINT:
      fprintf(fout,"imul\n");
      break;
    case tREAL:
      fprintf(fout,"fmul\n");
      break;
    case tSTRING:
      fprintf(fout,"istore 11\n");
      fprintf(fout,"astore 12\nldc \"\"\n");
      fprintf(fout,"%s:\n",currlabel);
      strcpy(lbl0,currlabel);
      incrlabel();
      fprintf(fout,"iload 11\n");
      fprintf(fout,"ifeq %s\n",currlabel);
      strcpy(lbl1,currlabel);
      incrlabel();
      fprintf(fout,"iinc 11 -1\n");
      fprintf(fout,"aload 12\n");
      fprintf(fout,"invokestatic cs132.Concat(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;\n");
      fprintf(fout,"goto %s\n",lbl0);
      fprintf(fout,"%s:\n",lbl1);
      break;
      /*array expressions skipped*/
  }
}

void gendivcode(int result)
{
  switch(result&taBOOLE)
    {
    case tINT:
      fprintf(fout,"idiv\n");
      break;
    case tREAL:
      fprintf(fout,"fdiv\n");
      break;
    case tSTRING:
      fprintf(fout,"invokestatic cs132.DropFront(Ljava/lang/String;I)Ljava/lang/String;\n");
      /*array expressions skipped*/
  }
}

void genmodcode(int result)
{
  /*no mod operations*/
  /*array expressions skipped*/
}

void genltcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"if_icmplt %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
    case tREAL:
      fprintf(fout,"fcmpl\n");
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void gengtcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"if_icmpgt %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
    case tREAL:
      fprintf(fout,"fcmpg\n");
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void geneqcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"if_icmpeq %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void genneqcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"if_icmpne %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void genlteqcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"if_icmple %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
    case tREAL:
      fprintf(fout,"fcmpl\n");
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void gengteqcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"if_icmpge %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
    case tREAL:
      fprintf(fout,"fcmpg\n");
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void gennotcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"ifeq %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
  }
}

void genorcode(int result)
{
  char lbl[6];

  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"ior %s\n",currlabel);
      strcpy(lbl,currlabel);
      incrlabel();
      fprintf(fout,"iconst_0\ngoto %s\n",currlabel);
      fprintf(fout,"%s:\niconst_1\n",lbl);
      fprintf(fout,"%s:\n",currlabel);
      incrlabel();
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void genandcode(int result)
{
  switch(result&taBOOLE)
    {
    case tBOOLE:
      fprintf(fout,"iand\n");
      break;
      /*no string comparisons*/
      /*array expressions skipped*/
  }
}

void genglobacc(char *prgid,char *funcid, int typ)
{
  switch(typ&taBOOLE)
    {
    case tREAL:
      fprintf(fout,"getstatic %s/%s F ; Get value of static field\n",prgid,funcid);
      break;
    case tINT:
      fprintf(fout,"getstatic %s/%s I ; Get value of static field\n",prgid,funcid);
      break;
    case tSTRING:
      fprintf(fout,"getstatic %s/%s Ljava/lang/String; ; Get value of static field\n",prgid,funcid);
      break;
    }
}

void genlocacc(int typ, int location)
{
  if (location<=3)
    {
      switch(typ&taBOOLE)
	{
	case tINT:
	  fprintf(fout,"iload_%d\n",location);
	  break;
	case tREAL:
	  fprintf(fout,"fload_%d\n",location);
	  break;
	case tSTRING:
	  fprintf(fout,"aload_%d\n",location);
	  break;
	case tBOOLE:
	  fprintf(fout,"iload_%d\n",location);
	  break;
	case taBOOLE:
	case taINT:
	case taSTRING:
	case taREAL:
	  fprintf(fout,"aload_%d\n",location);	  
	  break;
	  /*arrays would go here*/
	}
    }
  else
    {
      switch(typ&taBOOLE)
	{
	case tINT:
	  fprintf(fout,"iload %d\n",location);
	  break;
	case tREAL:
	  fprintf(fout,"fload %d\n",location);
	  break;
	case tSTRING:
	  fprintf(fout,"aload %d\n",location);
	  break;
	case tBOOLE:
	  fprintf(fout,"iload %d\n",location);
	  break;
	case taBOOLE:
	case taINT:
	case taSTRING:
	case taREAL:
	  fprintf(fout,"aload_%d\n",location);	  
	  break;
	  /*arrays would go here*/
	}
    }
}

void genconsti(int val)
{
  if ((val<=5)&&(val>=0))
    fprintf(fout,"iconst_%d\n",val);
  else
    fprintf(fout,"bipush %d\n",val);
}

void genconstf(rettype **val)
{
  fprintf(fout,"ldc %10f\n",(*val)->u.realval);

}

void genconsts(char *val)
{
  fprintf(fout,"ldc \"%s\"\n",val);

}

void genarrstore1(int loc)
{
  if (loc<=3)
    fprintf(fout,"aload_%d\n",loc);
  else
    fprintf(fout,"aload %d\n",loc);
}

void genarrstore2(int typ)
{
  fprintf(fout,"dup2_x1\npop2\n");
  switch (typ&taBOOLE)
    {
    case tINT:
      fprintf(fout,"iastore\n");
      break;
    case tREAL:
      fprintf(fout,"fastore\n");
      break;
    case tSTRING:
      fprintf(fout,"aastore\n");
      break;
    case tBOOLE:
      fprintf(fout,"iastore\n");
      break; 
    }
}

void genarridx(int mode,int last)
{
  
  if (((mode&8192)==8192)&&(last==0))
    fprintf(fout,"aaload\n");
  if (((mode&256)==256)&&(last==0))
    fprintf(fout,"aaload\n");
}

void genarrload1(int loc)
{
  if (loc<=3)
    fprintf(fout,"aload_%d\n",loc);
  else
    fprintf(fout,"aload_%d\n",loc);
}

void genarrload2(int typ)
{
  switch (typ&taBOOLE)
    {
    case tINT:
      fprintf(fout,"iaload\n");
      break;
    case tREAL:
      fprintf(fout,"faload\n");
      break;
    case tSTRING:
      fprintf(fout,"aaload\n");
      break;
    case tBOOLE:
      fprintf(fout,"iaload\n");
      break; 
    }
}

void genstore(int typ, int loc, char *varid, char *prgid)
{
  if (loc==-1)
    {
      fprintf(fout,"putstatic %s/%s ",prgid,varid);
      switch (typ&taBOOLE)
	{
	case tINT:
	  fprintf(fout,"I\n");
	  break;
	case tREAL:
	  fprintf(fout,"F\n");
	  break;
	case tSTRING:
	  fprintf(fout,"Ljava/lang/String;\n");
	  break;
	case tBOOLE:
	  fprintf(fout,"I\n");
	  break; 
	}
      return;
    }
  if (loc<=3)
    {
      switch (typ&taBOOLE)
	{
	case tINT:
	  fprintf(fout,"istore_%d\n",loc);
	  break;
	case tREAL:
	  fprintf(fout,"fstore_%d\n",loc);
	  break;
	case tSTRING:
	  fprintf(fout,"astore_%d\n",loc);
	  break;
	case tBOOLE:
	  fprintf(fout,"istore_%d\n",loc);
	  break; 
	}
    }
  else
    {
      switch (typ&taBOOLE)
	{
	case tINT:
	  fprintf(fout,"istore %d\n",loc);
	  break;
	case tREAL:
	  fprintf(fout,"fstore %d\n",loc);
	  break;
	case tSTRING:
	  fprintf(fout,"astore %d\n",loc);
	  break;
	case tBOOLE:
	  fprintf(fout,"istore %d\n",loc);
	  break; 
	}
    }
}

void genreadstmt(int typ)
{
  switch (typ&taBOOLE)
    {
    case tINT:
      fprintf(fout,"invokestatic cs132.IntRead()I\n");
      break;
    case tREAL:
      fprintf(fout,"invokestatic cs132.RealRead()F\n");
      break;
    case tSTRING:
      fprintf(fout,"invokestatic cs132.StrRead()Ljava/lang/String;\n");
      break;
    }

}

void genwritelnstmt(int typ)
{
  switch (typ&taBOOLE)
    {
    case tINT:
      fprintf(fout,"invokestatic cs132.IntWriteln(I)V\n");
      break;
    case tREAL:
      fprintf(fout,"invokestatic cs132.RealWriteln(F)V\n");
      break;
    case tSTRING:
      fprintf(fout,"invokestatic cs132.StrWriteln(Ljava/lang/String;)V\n");
      break;
    }

}

void genwritestmt(int typ)
{
  switch (typ&taBOOLE)
    {
    case tINT:
      fprintf(fout,"invokestatic cs132.IntWrite(I)V\n");
      break;
    case tREAL:
      fprintf(fout,"invokestatic cs132.RealWrite(F)V\n");
      break;
    case tSTRING:
      fprintf(fout,"invokestatic cs132.StrWrite(Ljava/lang/String;)V\n");
      break;
    }

}

void gennewarr(int typ, int dim, int loc)
{
  int i;
  if (loc!=-1)
    {
      if (dim==1)
	{
	  switch (typ&taBOOLE)
	    {
	    case taINT:
	      fprintf(fout,"newarray int\n");
	      break;
	    case taREAL:
	      fprintf(fout,"newarray float\n");
	      break;
	    case taSTRING:
	      fprintf(fout,"newarray Ljava/lang/String;\n");
	      break;
	    case taBOOLE:
	      fprintf(fout,"newarray boolean\n");
	      break;    
	    }
	}
      else
	{
	  fprintf(fout,"multianewarray ");
	  for(i=0;i<dim;i++)
	    fprintf(fout,"[");
	  switch (typ&taBOOLE)
	    {
	    case taINT:
	      fprintf(fout,"I");
	      break;
	    case taREAL:
	      fprintf(fout,"F");
	      break;
	    case taSTRING:
	      fprintf(fout,"Ljava/lang/String;");
	      break;
	    case taBOOLE:
	      fprintf(fout,"I");
	      break;    
	    }
	  fprintf(fout," %d\n",dim);
	}
      if (loc<=3)
	fprintf(fout,"astore_%d\n",loc);
      else
	fprintf(fout,"astore %d\n",loc);
    }

}

void gencast(int ty1, int ty2)
{
  switch(ty1&tBOOLE)
    {
    case tREAL:
      if ((ty2&tBOOLE)==tINT)
	{
	  fprintf(fout,"i2f\n");
	}
      break;
    case tINT:
      if ((ty2&tBOOLE)==tREAL)
	{
	  fprintf(fout,"f2i\n");
	}     
      break;
    case tBOOLE:
      break;
    }
}

void genbcast(int typ=0)
{
  switch(typ&taBOOLE)
    {
    case tINT:
      break;
    case tREAL:
      fprintf(fout,"f2i\n");
      break;
    case tSTRING:
      break;
    case tBOOLE:
      break;
    }
}

void genop1cast(int t1, int t2)
{
  if (((t2&taBOOLE)==tREAL) && ((t1&taBOOLE)==tINT))
    gencast(t2,t1);
}

void genop2cast(int t1, int t2)
{
  if (((t1&taBOOLE)==tREAL) && ((t2&taBOOLE)==tINT))
    gencast(t1,t2);
}

void genifstmt(char *lbl)
{
  fprintf(fout,"ifeq %s\n",currlabel);
  strcpy(lbl,currlabel);
  incrlabel();
}

void genelsestmt(char *lbl,char *lbl2)
{
  fprintf(fout,"goto %s\n",currlabel);
  strcpy(lbl2,currlabel);
  incrlabel();
  fprintf(fout,"%s:\n",lbl);
}

void genendif(char *lbl)
{
  fprintf(fout,"%s:\n",lbl);
}

void genwhilebgn(char *lbl)
{
  fprintf(fout,"%s:\n",currlabel);
  strcpy(lbl,currlabel);
  incrlabel();
}

void genwhilechk(char *lbl)
{
  fprintf(fout,"ifeq %s\n",currlabel);
  strcpy(lbl,currlabel);
  incrlabel();
}

void genwhileend(char *lbl0, char *lbl1)
{
  fprintf(fout,"goto %s\n%s:\n",lbl0,lbl1);
}

#endif
